﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	
	Public SQL1 As SQL
	Public SQLDataBasePath, SQLDataBaseName As String

	Public CurrentIndex As Int		'index of the current entry
	Public RowNumber As Int				'number of rows
	
	Public IDList As List		'list containing the IDs of the database
	'we need it because the IDs can be different from the list indexes
	'if we delete an entry its ID is lost

	'Variables for Edit ... the Edit Activity has two modes  "Add"  and "Edit"
	Public EditMode As String

	'variable for the filter query... defined in the btnFilter_Click routine
	'and will be used In the DBWebView ShowTable routine
	Public FilterQuery As String
	
	'flag for the filter active or inactive
	Public flagFilterActive As Boolean
	
	'Boolean operator used in the filter ... can be OR or AND
	Public FilterBooleanOperator As String
	
	'Variables used to hold the selected indexes of the Spinners
	Public SelectedFirstName = 0 As Int
	Public SelectedLastName = 0 As Int
	Public SelectedCity = 0 As Int
	
End Sub

Sub Service_Create
	'initialize the variables
	CurrentIndex = -1
	RowNumber = 0
	EditMode = "Add"
	FilterQuery = ""
	flagFilterActive = False
	FilterBooleanOperator = "OR "
	
	SQLDataBasePath = File.DirInternal
	SQLDataBaseName = "studentdbteachers.db"
	
	'...............................................................................................................................................................................................................
	'@@@ Debug only for testing, deletes db, drops / creates tables etc
	'to MANUALLY build a fresh db from scratch run the following lines (possible with a SLEEP(200) between each if neccessary
	
	'File.Delete(SQLDataBasePath, SQLDataBaseName) 
	'SQL1.Initialize(SQLDataBasePath, SQLDataBaseName,	True)   'True ... we want to create new one if not present
	'DropTables		  'not neccessary .. it should be an empty db
	'CreateTables


	'@@@ If you run the above code  , You would rem / comment the initialize section below
	'................................................................................................................................................................................................................
	
	
	'@@@  The database in assets is now a fully built db using the CreateTable sub below
	'  (the Class Table already includes INSERTED data)
	
	'check if the database already exists .. if not copy default from assets and initialize
	If Not(File.Exists(SQLDataBasePath, SQLDataBaseName)) Then
		File.Copy(File.DirAssets, SQLDataBaseName, SQLDataBasePath, SQLDataBaseName)
		SQL1.Initialize(SQLDataBasePath, SQLDataBaseName,	False)   'false ... we do not want to create new one
	
	Else		'file exists .. so initialize		
		SQL1.Initialize(SQLDataBasePath, SQLDataBaseName, False)		
	End If
	
	
	Private query As String = "INSERT INTO Register VALUES ('256','0782911364', 'makumbisula@yahoo.com','Father','2')"
	SQL1.ExecNonQuery(query)
	
End Sub

Sub DropTables
	SQL1.ExecNonQuery("DROP TABLE IF EXISTS Register")
	SQL1.ExecNonQuery("DROP TABLE IF EXISTS Activeclass")
	SQL1.ExecNonQuery("DROP TABLE IF EXISTS Classes")
	SQL1.ExecNonQuery("DROP TABLE IF EXISTS Sentmessages")
	SQL1.ExecNonQuery("DROP TABLE IF EXISTS Recievedsms")
	SQL1.ExecNonQuery("DROP TABLE IF EXISTS SMSlist")
	SQL1.ExecNonQuery("DROP TABLE IF EXISTS Student")
	SQL1.ExecNonQuery("DROP TABLE IF EXISTS  Eventsinfo ")
	SQL1.ExecNonQuery("DROP TABLE IF EXISTS Academics")
	SQL1.ExecNonQuery("DROP TABLE IF EXISTS Allacounts")
	SQL1.ExecNonQuery("DROP TABLE IF EXISTS Balances")
	SQL1.ExecNonQuery("DROP TABLE IF EXISTS Statement")
	SQL1.ExecNonQuery("DROP TABLE IF EXISTS Balances2")
End Sub
	
Sub CreateTables
	
	Private query As String
	'SECONDARY
	query = "CREATE TABLE Classes (Class Text, ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE)"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('S1', '1')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('S2', '2')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('S3', '3')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('S4', '4')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('S5', '5')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('S6', '6')"
	'PRIMARY
	query = "INSERT INTO Classes VALUES ('PRE', '11')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('P1', '12')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('P2', 13)"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('P3', '14')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('P4', '15')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('P5', '16')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('P6', '17')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Classes VALUES ('P7', '18')"
	SQL1.ExecNonQuery(query)

	query = "CREATE TABLE Activeclass (Account Text,Name Text, Class Text, stream Text, ID INTEGER)"
	SQL1.ExecNonQuery(query)
	
	query = "CREATE TABLE SMSlist (Account Text, Names Text,Phone text,Sex, ID INTEGER )"
	SQL1.ExecNonQuery(query)
	
	query = "CREATE TABLE Sentmessages (Datesent Text, Sms text,ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE)"
	SQL1.ExecNonQuery(query)
		
	query = "CREATE TABLE Recievedsms (Daterecieved Text, Sms text,Name text, ID INTEGER)"
	SQL1.ExecNonQuery(query)
	
	query = "CREATE TABLE Student ( Account TEXT, Names TEXT, Class TEXT, Stream TEXT, Amount REAL, Dates TEXT, id INTEGER Not Null PRIMARY KEY AUTOINCREMENT UNIQUE, Years TEXT, Term TEXT )"
	SQL1.ExecNonQuery(query)
	
	query = "CREATE TABLE Register (Code TEXT, Phone TEXT, Email TEXT, Sex TEXT, ID INTEGER)"
	SQL1.ExecNonQuery(query)
		
	query = "CREATE TABLE Allacounts (Account Text, Phone text, ID INTEGER )"
	SQL1.ExecNonQuery(query)
	
	query =  "CREATE TABLE Balances (Account Text,Names text, Class text,Stream text,Amount NUMERIC, ID INTEGER )"
	SQL1.ExecNonQuery(query)
	
	query =  "CREATE TABLE Balances2 (Account Text,Names text, Class text,Stream text,Amount REAL, ID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE)"
	SQL1.ExecNonQuery(query)
	
	query =   "CREATE TABLE Eventsinfo (Events TEXT, Class TEXT,Stream TEXT, Dates TEXT,	Id	INTEGER Not Null PRIMARY KEY AUTOINCREMENT UNIQUE,Term TEXT,Years TEXT)"
	SQL1.ExecNonQuery(query)
	
	query =   "CREATE TABLE Academics ( Names TEXT, Class TEXT, Stream TEXT, Subject TEXT, Total NUMERIC, Grade TEXT, Mid NUMERIC,Ends NUMERIC,Term TEXT, Years TEXT, id INTEGER )"
	SQL1.ExecNonQuery(query)
	
	query =   "CREATE TABLE Statement (Account TEXT, Names TEXT, Descript TEXT, DebitAmnt TEXT,CreditAmnt TEXT, TRef TEXT,TRDate TEXT,Bal TEXT)"
	SQL1.ExecNonQuery(query)
		
	'query =   "CREATE VIEW Singlebal AS Select Balances.Amount FROM Balances INNER JOIN Allacounts ON Balances.Account = Allacounts.Account "
	'SQL1.ExecNonQuery(query)
		
End Sub

Private Sub CreateMessage(Body As String) As Byte()
	'Dim m As Message
	'm'.'
	'm.Body = Body
	'm.From = "currentName"
End Sub

Public Sub SendMessage(Body As String)
	CreateMessage(Body)
	'client.Publish2("all", CreateMessage(Body), 0, False)

End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Sub Service_Destroy

End Sub